#include <CORBA-SMALL.h>
#include "printer.h"

int main( int argc, char *argv[] )
{
    // ORB initialization
    CORBA::ORB_var orb = CORBA::ORB_init( argc, argv, "mico-local-orb" );
    CORBA::BOA_var boa = orb->BOA_init (argc, argv, "mico-local-boa");

    // client side
    assert (argc == 2);
    CORBA::ORB::ObjectTag_var tag = CORBA::ORB::string_to_tag ("prn0");
    /*
     * bind to an instance of type "IDL:Printer:1.0" whose ReferenceData
     * equals "prn0".
     */
    CORBA::Object_var obj = orb->bind ("IDL:Printer:1.0", tag.in(), argv[1]);
    assert (!CORBA::is_nil (obj));
    Printer_var client = Printer::_narrow( obj );
	client->setId(0);

	char text[][60] = {"Great Message to be printed again and again and again", "Another Message", "Divine Message", "This is a warning", "Insane Message", "Not yet over", "getting over", "Yo", "Is it over", "No it is not", "Thats over"};
	
	for(int i=0; i<11; i++) 
		client->print(text[i]);

    return 0;
}

