#include <CORBA-SMALL.h>
#include "mserver.h"

int main( int argc, char *argv[] )
{
    // ORB initialization
    CORBA::ORB_var orb = CORBA::ORB_init( argc, argv, "mico-local-orb" );
    CORBA::BOA_var boa = orb->BOA_init (argc, argv, "mico-local-boa");

    // client side
    assert (argc == 2);
    CORBA::ORB::ObjectTag_var tag = CORBA::ORB::string_to_tag ("foobar");
    /*
     * bind to an instance of type "IDL:MessageServer:1.0" whose ReferenceData
     * equals "foobar".
     */
    CORBA::Object_var obj = orb->bind ("IDL:MessageServer:1.0", tag.in(), argv[1]);
    assert (!CORBA::is_nil (obj));
    MessageServer_var client = MessageServer::_narrow( obj );


	char text[][30] = {"Great Message", "Another Message", "Divine Message", "This is a warning", "Insane Message"};
	char addr[][30] = {"neon.sit.iitb.ac.in", "144.16.116.128", "alps", "cygnus", "president@whitehose.gov"};
	
	for(int i=0; i<5; i++) 
		client->send(text[i],addr[i]);

    return 0;
}

