#include <CORBA-SMALL.h>
#include <iostream.h>
#include "money.h"
#include "account.h"
#include "account1.h"
 
int main( int argc, char *argv[] )
{
    // ORB initialization
    CORBA::ORB_var orb = CORBA::ORB_init( argc, argv, "mico-local-orb" );
    CORBA::BOA_var boa = orb->BOA_init (argc, argv, "mico-local-boa");

    // client side
    assert (argc == 3);
    CORBA::ORB::ObjectTag_var tag = CORBA::ORB::string_to_tag ("foobar");
    /*
     * bind to an instance of type "IDL:Account:1.0" whose ReferenceData
     * equals "foobar".
     */

	Money m, b;

	if( argv[2][0] == '1' )
	{
		cout << "SERVER 1\n";
    	CORBA::Object_var obj = orb->bind ("IDL:Account:1.0", tag.in(), argv[1]);
    	assert (!CORBA::is_nil (obj));
    	Account_var client = Account::_narrow( obj );

		m.cash = 100;
    	for(int i=0; i<1; i++)
			client->deposit( m );
    	for(int i=0; i<1; i++)
    		client->withdraw( m );
		b = client->balance();
    	cout << "Balance is " << b.cash << endl << flush ;
	}
	else
	{
		cout << "SERVER 2\n";
    	CORBA::Object_var obj = orb->bind ("IDL:Account1:1.0", tag.in(), argv[1]);
    	assert (!CORBA::is_nil (obj));
    	Account1_var client = Account1::_narrow( obj );

		m.cash = 100;
    	for(int i=0; i<1; i++)
			client->deposit( m );
    	for(int i=0; i<1; i++)
    		client->withdraw( m );
		b = client->balance();
    	cout << "Balance is " << b.cash << endl << flush ;
	}
	
    return 0;
}
