#include <CORBA-SMALL.h>
#include <iostream.h>
#include <string.h>
#include "server.h"
#include <sys/time.h>

int main( int argc, char *argv[] )
{
    // ORB initialization
    CORBA::ORB_var orb = CORBA::ORB_init( argc, argv, "mico-local-orb" );
    CORBA::BOA_var boa = orb->BOA_init (argc, argv, "mico-local-boa");

    struct timeval t1,t0;
	long diff;
		
    // client side
    assert (argc == 3);
    CORBA::ORB::ObjectTag_var tag = CORBA::ORB::string_to_tag (argv[2]);

	CORBA::Long arg;

	if( !strcmp(argv[2], "local") )
	{
		cout << "LOCAL SERVER\n";
		arg = 10;
	}
	else if( !strcmp(argv[2], "remote") )
	{
		cout << "REMOTE SERVER\n";
		arg = 20;
	}
	else
		assert(0);

	cout << "Before bind : " << argv[1] << " : " << argv[2] << "\n" << flush;
    CORBA::Object_var obj = orb->bind ("IDL:Server:1.0", tag.in(), argv[1]);
    assert (!CORBA::is_nil (obj));
    Server_var client = Server::_narrow( obj );

	CORBA::Short result = client->test( 0 );

	cerr << "With BOUNCE\n" << flush;
	gettimeofday(&t0,NULL);
	result = client->test( arg );
	gettimeofday(&t1,NULL);
	diff = (long)( (t1.tv_sec - t0.tv_sec) * 1E+6 ) + t1.tv_usec - t0.tv_usec;
	cout << "Time(in microsecs) for 'test' = " << diff << "\n" << flush;
	cout << "Result = " << result << "\n" << flush;

	cerr << "Without BOUNCE\n" << flush;
	gettimeofday(&t0,NULL);
	result = client->test( 0 );
	gettimeofday(&t1,NULL);
	diff = (long)( (t1.tv_sec - t0.tv_sec) * 1E+6 ) + t1.tv_usec - t0.tv_usec;
	cout << "Time(in microsecs) for 'test' = " << diff << "\n" << flush;
	cout << "Result = " << result << "\n" << flush;
	
    return 0;
}
