/*
 *  Filter Object Framework for MICO
 *	Pranav Nabar & Amit Padalkar
 *	8 Jan 2002
 */
 
#ifndef FILTER_CONFIG_H

#define FILTER_CONFIG_H

#include <CORBA-SMALL.h>
#include "lexer.h"

//#define FCONF_DEBUG		// Uncomment this line to get filterconf debug messages

enum NameServStatus
{
	NSNone,
	NSAll,
	NSFilter,
	NSClient
};

class Config
{
private:
	string file;
	string address;
	bool isKey;
	string key;
	NameServStatus idStatus;
	bool isEnable;
	bool isDisable;
	bool isMapping;
	bool isPlug;
	bool isUnplug;
	bool isTime;
	bool isAddrFromFile;
	Lexer lexer;
	CORBA::ORB_var orb;
	CORBA::BOA_var boa;

	void usage();
	string getEnvVal( const string &name );
	void getInfo( vector<string> &values, bool allowNil, bool allowUpDn = false ) throw(ConfigError);
	void getID( string section, vector<string> &id ) throw(ConfigError);
	CORBA::Object_var getObjFromRepo( const vector<string> &id ) throw(ConfigError);
	CORBA::Object_var getObjFromNS( const vector<string> &id ) throw(ConfigError);
	int getRepoId( const vector<string> &ids, int start, vector<string> &id ) throw(ConfigError);
	int getNSId( const vector<string> &ids, int start, vector<string> &id ) throw(ConfigError);
	void handleFilter( const string &section ) throw(ConfigError);
	void handleClient( const string &section ) throw(ConfigError);
	streampos findKey(const string &skey = "") throw(ConfigError);
	streampos skipSection() throw(ConfigError);
	bool isSectionKeyword( const string &skey );
	bool isSectionToken( Tokens tok );

public:
	Config(int argc, char *argv[]);
	void parse() throw(ConfigError);
};

#endif

